/*******************************************************************************
 * Copyright (c) 2025, Jan Koester jan.koester@gmx.net
 * All rights reserved.
 * * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 * Neither the name of the <organization> nor the
 * names of its contributors may be used to endorse or promote products
 * derived from this software without specific prior written permission.
 * * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *******************************************************************************/

#pragma once

#include <string>
#include <vector>
#include <cstdint>
#include<chrono>

#include "rsa.h"

namespace netplus {

    struct ASN1Node {
        uint8_t tag = 0;
        const uint8_t* data = nullptr;
        size_t len = 0;
        std::vector<ASN1Node> children;
    };

    struct X509State {
        std::vector<uint8_t> der;
        ASN1Node root;
    };

    class x509cert {
    private:
        std::shared_ptr<X509State> state;

    public:
        x509cert();
        x509cert(const x509cert&) = default;
        x509cert& operator=(const x509cert&) = default;

        x509cert(x509cert&&) noexcept = default;
        x509cert& operator=(x509cert&&) noexcept = default;

        const std::vector<uint8_t>& derData() const { return state->der; }
        std::vector<uint8_t>& derData() { return state->der; }

        bool loadFromBuffer(std::vector<uint8_t>&& buffer);
        bool loadFromBuffer(const std::vector<uint8_t>& buffer);
        bool loadFromFile(const std::string& path);

        bool checkValidity();
        bool extractPublicKey(netplus::rsa& outRsa);
        std::string getSubjectCN();
        std::vector<std::string> getSubjectAltNames();
        std::string decodeOID(const uint8_t* data, size_t len);
        time_t parseASN1Time(const uint8_t* data, size_t len, uint8_t tag);
        std::vector<uint8_t> pemCertToDer(const std::string& pem);
        void bytesToBigInt(const std::vector<uint8_t>& bytes, netplus::rsa::bigInt& out);
    private:
        size_t parseInternal(const uint8_t* data, size_t size, ASN1Node& outNode);

        // Helper um bequem root zu bekommen
        ASN1Node& root() { return state->root; }
        const ASN1Node& root() const { return state->root; }
        friend class ssl;
    };

};
